﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@

Sub Process_Globals
	Public pool As ABHikariCP
	
	Public DBOK As Int = 0
	Public DBERROR As Int = -1
	Public DBNORESULTS As Int = -2
	
	Public LastErrorMessage As String
End Sub

Sub InitializeMySQL(jdbcUrl As String ,login As String, password As String, poolSize As Int) 'ignore
	pool.Initialize("com.mysql.jdbc.Driver", jdbcUrl, login, password)
	pool.MaxLifetime = 1800000
	
	Dim jocp As JavaObject = pool
	jocp.RunMethod("setMaximumPoolSize", Array(poolSize))
	jocp.RunMethod("addDataSourceProperty", Array("cachePrepStmts", True))
	jocp.RunMethod("addDataSourceProperty", Array("prepStmtCacheSize", 250))
	jocp.RunMethod("addDataSourceProperty", Array("prepStmtCacheSqlLimit", 2048))
	jocp.RunMethod("addDataSourceProperty", Array("useServerPrepStmts", True))
	jocp.RunMethod("addDataSourceProperty", Array("useLocalSessionState", True))
	jocp.RunMethod("addDataSourceProperty", Array("useLocalTransactionState", True))
	jocp.RunMethod("addDataSourceProperty", Array("rewriteBatchedStatements", True))
	jocp.RunMethod("addDataSourceProperty", Array("cacheResultSetMetadata", True))
	jocp.RunMethod("addDataSourceProperty", Array("cacheServerConfiguration", True))
	jocp.RunMethod("addDataSourceProperty", Array("elideSetAutoCommits", True))
	jocp.RunMethod("addDataSourceProperty", Array("maintainTimeStats", True))
	
	Dim thres As Long = 60000
	jocp.RunMethod("setLeakDetectionThreshold", Array(thres))
End Sub

Public Sub GetSQL() As SQL
	Return pool.GetConnection
End Sub

public Sub CloseSQL(SQL As SQL)
	SQL.Close
End Sub

Sub SQLSelect(SQL As SQL, Query As String, args As List) As List 'ignore
	LastErrorMessage = ""
	Dim l As List
	l.Initialize
	Dim cur As ResultSet
	Try
		cur = SQL.ExecQuery2(Query, args)
	Catch
		LastErrorMessage = LastException.Message
		Return l
	End Try
	Do While cur.NextRow
		Dim res As Map
		res.Initialize
		For i = 0 To cur.ColumnCount - 1
			res.Put(cur.GetColumnName(i).ToLowerCase, cur.GetString2(i))
		Next
		l.Add(res)
	Loop
	cur.Close
	Return l
End Sub

Sub SQLSelectSingleResult(SQL As SQL, Query As String, args As List) As String 'ignore
	LastErrorMessage = ""
	Dim res As String
	Try
		res = SQL.ExecQuerySingleResult2(Query, args)
	Catch
		LastErrorMessage = LastException.Message
		res = DBERROR
	End Try
	If res = Null Then
		res = DBNORESULTS
	End If
	Return res
End Sub

Sub SQLInsert(SQL As SQL, Query As String, Args As List, oneResult As Boolean) As Int 'ignore
	LastErrorMessage = ""
	Dim res As Int = DBOK
	Try
		SQL.ExecNonQuery2(Query, Args)
		If oneResult Then
			res = SQL.ExecQuerySingleResult2("SELECT LAST_INSERT_ID()", Null)
		End If
	Catch
		LastErrorMessage = LastException.Message
		res = DBERROR
	End Try
	
	Return res
End Sub

Sub SQLUpdate(SQL As SQL, Query As String, Args As List) As Int 'ignore
	LastErrorMessage = ""
	Dim res As Int = DBOK
	Try
		SQL.ExecNonQuery2(Query, Args)
	Catch
		LastErrorMessage = LastException.Message
		res = DBERROR
	End Try
	
	Return res
End Sub

Sub SQLDelete(SQL As SQL, Query As String, Args As List) As Int 'ignore
	LastErrorMessage = ""
	Dim res As Int = DBOK
	Try
		SQL.ExecNonQuery2(Query, Args)
	Catch
		LastErrorMessage = LastException.Message
		res = DBERROR
	End Try
	
	Return res
End Sub